/**
 * 监听组件
 */
const chokidar = require('chokidar');

const Log = require('./log');

let watcher;

module.exports = {
  /**
   * init
   * @param watchPaths
   * @param opts
   */
  async init(watchPaths, opts) {
    if (watcher) {
      await watcher.close();
    }

    opts = opts || {};
    const unWatchPaths = opts.unWatchPaths || undefined;

    watcher = chokidar.watch(watchPaths, {
      ignored: /(^|[\/\\])\../, // ignore dotfiles
    });

    if (unWatchPaths) {
      await watcher.unwatch(unWatchPaths);
    }

    watcher
      .on('ready', () => Log.info(`Initial scan complete. Ready for changes. watchPaths: ${watchPaths}`))
      .on('error', error => console.log(`Watcher error: ${error}`));
    return watcher;
  },
};
